cimport numpy as np
import cython
import numpy as np


cdef extern int medianfilter_main_float(float* Input, float* Output, int radius, int dimX, int dimY, int dimZ);

def MEDIAN_CPU(inputData, radius):
    if inputData.ndim == 2:
        return MEDIAN_2D(inputData, radius)

def MEDIAN_2D(np.ndarray[np.float32_t, ndim=2, mode="c"] inputData,
                     int radius):

    cdef long dims[2]
    dims[0] = inputData.shape[0]
    dims[1] = inputData.shape[1]

    cdef np.ndarray[np.float32_t, ndim=2, mode="c"] outputData = \
            np.zeros([dims[0],dims[1]], dtype='float32')

    medianfilter_main_float(&inputData[0,0], &outputData[0,0],
                       radius,
                       dims[1],dims[0], 0)

    return outputData
